var EXPORTED_SYMBOLS = ["ProfilePasswordMain"];
var ProfilePasswordMain = {
	migratePrefs : function() {
		try {
			if (ProfilePasswordMain.prefs.getPrefType("mails.headers.hex_number")  != 0) 
				ProfilePasswordMain.prefs.setCharPref("extensions.profilepassword.magic_hex_number", ProfilePasswordMain.prefs.getCharPref("mails.headers.hex_number"));
			ProfilePasswordMain.prefs.deleteBranch("mails.headers.hex_number");
		}
		catch(e) {}
		if (ProfilePasswordMain.prefs.getPrefType("profilepassword.auto_offline")  != 0)  {
			ProfilePasswordMain.prefs.setBoolPref("extensions.profilepassword.auto_offline", ProfilePasswordMain.prefs.getBoolPref("profilepassword.auto_offline"));
			ProfilePasswordMain.prefs.setBoolPref("extensions.profilepassword.uninstall.delete_password", ProfilePasswordMain.prefs.getBoolPref("profilepassword.uninstall.delete_password"));
			ProfilePasswordMain.prefs.deleteBranch("profilepassword.");
		}
	},

	getPassword : function() {
		if (ProfilePasswordMain.prefs.getPrefType("extensions.profilepassword.magic_hex_number")  == 0) 
			return null;
		var rightpass = ProfilePasswordMain.prefs.getCharPref("extensions.profilepassword.magic_hex_number");
		var word = "";
		for (var i=4; i<rightpass.length; i=i+2) 	{
			var test = rightpass.slice(i,i+2);
			word = word + String.fromCharCode(parseInt(test,16));
		}
		return word;
	},

	start : function(win) {
		if (ProfilePasswordMain.promptOn) {
			win.close();
			return;
		}
		if (ProfilePasswordMain.unlocked && ! ProfilePasswordMain.lockOn)
			return;
		ProfilePasswordMain.prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		var strBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
		ProfilePasswordMain.bundle = strBundleService.createBundle("chrome://profilepass/locale/profilepass.properties"); 
		ProfilePasswordMain.migratePrefs();
		if  (ProfilePasswordMain.prefs.getPrefType("extensions.profilepassword.magic_hex_number")  == 0) {
			ProfilePasswordMain.unlocked = true;
			return;
		}
		ProfilePasswordMain.promptOn = true;
		ProfilePasswordMain.unlocked = false;
		ProfilePasswordMain.getPrompt(win);
	},

	getPrompt : function(win) {
		var PPpromptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
		var passwObj = new Object();
		var checkObj = new Object();
		var onoff = true;
		var answer = ProfilePasswordMain.getPassword();
		var wasOnline = false;
		passwObj.value = "";
		checkObj.value = true;
		var offlineManager = null;
		var isOnline = true;
		try {
			if (goOffline) {
				isOnline = MailOfflineMgr.isOnline();
				offlineManager = Components.classes["@mozilla.org/messenger/offline-manager;1"]                 
       		                	.getService(Components.interfaces.nsIMsgOfflineManager);
				if (isOnline) 
					offlineManager.synchronizeForOffline(false, false, false, true, msgWindow);
			}
		}
		catch(e) {} 
		var text = ProfilePasswordMain.bundle.GetStringFromName("passrequest");
		while (passwObj.value != answer && onoff) {
			onoff = PPpromptService.promptPassword(null ,  "ProfilePassword", text, passwObj, "", checkObj);
			if (passwObj.value != answer && onoff == true)
				ProfilePasswordMain.writeLog(0);
		}
		ProfilePasswordMain.promptOn = false;
		if (! onoff) {
			ProfilePasswordMain.writeLog(1);
			if (win)
				ProfilePasswordMain.quit(win);
			else
				return false;
		}
		else {
			try {
				if (offlineManager && isOnline && goOffline) 
					offlineManager.goOnline(false, false, msgWindow);
			}
			catch(e) {}
			ProfilePasswordMain.unlocked = true;
			return true;
		}
	},

	quit : function(win) {
		var WM = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
		var wins = WM.getEnumerator(null);
		if (wins.hasMoreElements()) 
			win.close();
		else {
			var appStartup = Components.classes["@mozilla.org/toolkit/app-startup;1"].getService(Components.interfaces.nsIAppStartup);
			appStartup.quit(Components.interfaces.nsIAppStartup.eAttemptQuit);
		}
	},

	writeLog : function(type) {
		var now = new Date();
		var file = Components.classes["@mozilla.org/file/directory_service;1"]
			.getService(Components.interfaces.nsIProperties)
			.get("ProfD", Components.interfaces.nsIFile);
		var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
		file.append("profilepassword.log");
		if (file.exists() && file.fileSize > 204800)
			var flag = "0x20";
		else
			var flag = "0x10";
		foStream.init(file, 0x02 | 0x08 | flag, 0664, 0);
		if (type == 0)
			var data =  "Failed login (wrong password) at: "+now.toLocaleString()+"\r\n";
		else if (type == 1)
			var data =  "Failed login (prompt canceled) at: "+now.toLocaleString()+"\r\n";
		else if (type == 2)
			var data =  "Uninstall request at: "+now.toLocaleString()+"\r\n";
		foStream.write(data, data.length);
		foStream.close();
	}
};

